local use_test = {} -- overwritten by on_init/on_load
local playerdata = {}

local ename={} for k,v in next,defines.events do ename[v]=k end
function ccchanged(ev)
    print(serpent.line{ename[ev.name],ev})
    end
function conditional_hooks() -- final setup
    if global.use_test then
	remote.call('testocc','test',playerdata)
    else
	script.on_event(defines.events.on_player_cursor_stack_changed,ccchanged)
	end
    end

function configuration_changed(ccdata) -- pre-on_load for map in new mod env
    print(serpent.block(ccdata or 'o-c-c from on-init'))
    do local _=remote.interfaces.testocc or {}
	global.use_test = _.test or false
	print(serpent.line{map_global_use_test=global.use_test})
	end
    end

script.on_configuration_changed(configuration_changed)

function reload() -- prep local lua env from on_init and on_load, then setup engine
    use_test = global.use_test
    playerdata = global.playerdata
    conditional_hooks()
    print(serpent.line{'reloaded globals:',playerdata=playerdata,use_test=use_test})
    end

script.on_init(function()
    configuration_changed()
    global.playerdata = playerdata
    return reload()
    end)
script.on_load(reload)

script.on_event(defines.events.on_player_joined_game,function(ev)
    if not playerdata[ev.player_index] then
	playerdata[ev.player_index]={}
	end
    end)
-- vim: set sw=4 sts=4 lbr wrap tw=78 :
